import { Base, Type } from "igniteui-react-core";
import { PrimitiveVisualData } from "igniteui-react-core";
import { LinearScaleVisualData } from "./LinearScaleVisualData";
import { LinearGraphScaleLabelVisualDataList } from "./LinearGraphScaleLabelVisualDataList";
import { LinearGraphScaleTickmarkVisualDataList } from "./LinearGraphScaleTickmarkVisualDataList";
import { LinearGraphRangeVisualDataList } from "./LinearGraphRangeVisualDataList";
import { LinearGraphToolTipVisualData } from "./LinearGraphToolTipVisualData";
import { RectData } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class LinearGraphVisualData extends Base {
    static $t: Type;
    private _scalePath;
    get scalePath(): PrimitiveVisualData;
    set scalePath(a: PrimitiveVisualData);
    private _backingPath;
    get backingPath(): PrimitiveVisualData;
    set backingPath(a: PrimitiveVisualData);
    private _underlayPath;
    get underlayPath(): PrimitiveVisualData;
    set underlayPath(a: PrimitiveVisualData);
    private _overlayPath;
    get overlayPath(): PrimitiveVisualData;
    set overlayPath(a: PrimitiveVisualData);
    private _scale;
    get scale(): LinearScaleVisualData;
    set scale(a: LinearScaleVisualData);
    private _scaleLabels;
    get scaleLabels(): LinearGraphScaleLabelVisualDataList;
    set scaleLabels(a: LinearGraphScaleLabelVisualDataList);
    private _scaleTickmarks;
    get scaleTickmarks(): LinearGraphScaleTickmarkVisualDataList;
    set scaleTickmarks(a: LinearGraphScaleTickmarkVisualDataList);
    private _ranges;
    get ranges(): LinearGraphRangeVisualDataList;
    set ranges(a: LinearGraphRangeVisualDataList);
    private _toolTip;
    get toolTip(): LinearGraphToolTipVisualData;
    set toolTip(a: LinearGraphToolTipVisualData);
    private _name;
    get name(): string;
    set name(a: string);
    scaleByViewport(): void;
    serialize(): string;
    private _viewport;
    get viewport(): RectData;
    set viewport(a: RectData);
}
