import { Type } from "igniteui-react-core";
/**
 * Enum specifying various preset needle shapes.
 */
export declare enum RadialGaugeNeedleShape {
    /**
     * No shape.
     */
    None = 0,
    /**
     * A rectangle shape.
     */
    Rectangle = 1,
    /**
     * A triangle shape.
     */
    Triangle = 2,
    /**
     * A needle shape.
     */
    Needle = 3,
    /**
     * A trapezoid shape.
     */
    Trapezoid = 4,
    /**
     * A rectangle shape with a bulb at the end.
     */
    RectangleWithBulb = 5,
    /**
     * A triangle shape with a bulb at the end.
     */
    TriangleWithBulb = 6,
    /**
     * A needle shape with a bulb at the end.
     */
    NeedleWithBulb = 7,
    /**
     * A trapezoid shape with a bulb at the end.
     */
    TrapezoidWithBulb = 8
}
/**
 * @hidden
 */
export declare let RadialGaugeNeedleShape_$type: Type;
