import { Type } from "igniteui-react-core";
/**
 * Enum specifying shapes for the needle pivot.
 */
export declare enum RadialGaugePivotShape {
    /**
     * No pivot shape.
     */
    None = 0,
    /**
     * A circle shaped pivot.
     */
    Circle = 1,
    /**
     * A circle pivot with a hole in it.
     */
    CircleWithHole = 2,
    /**
     * A circle pivot overlayed on top of the needle.
     */
    CircleOverlay = 3,
    /**
     * A circle pivot with a hole in it overlayed on top of the needle.
     */
    CircleOverlayWithHole = 4,
    /**
     * A circle pivot rendered underneath the needle.
     */
    CircleUnderlay = 5,
    /**
     * A circle pivot with a hold in it rendered underneath the needle.
     */
    CircleUnderlayWithHole = 6
}
/**
 * @hidden
 */
export declare let RadialGaugePivotShape_$type: Type;
