import { Control } from "igniteui-react-core";
import { INotifyPropertyChanged, Base, PropertyChangedEventArgs, Type, Point } from "igniteui-react-core";
import { DoubleAnimator } from "igniteui-react-core";
import { BulletGraphFrame } from "./BulletGraphFrame";
import { LinearGraphScaler } from "./LinearGraphScaler";
import { LinearScaleOrientation } from "./LinearScaleOrientation";
import { DependencyProperty } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { LinearGraphRangeCollection } from "./LinearGraphRangeCollection";
import { BrushCollection } from "igniteui-react-core";
import { HighlightedValueDisplayMode } from "igniteui-react-core";
import { BindingFormatter } from "igniteui-react-core";
import { StackPool$1 } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { TextBlock } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { FormatLinearGraphLabelEventArgs } from "./FormatLinearGraphLabelEventArgs";
import { AlignLinearGraphLabelEventArgs } from "./AlignLinearGraphLabelEventArgs";
import { BulletGraphVisualData } from "./BulletGraphVisualData";
import { ToolTipInfo } from "./ToolTipInfo";
import { LinearGraphTooltipDataContext } from "./LinearGraphTooltipDataContext";
import { Size } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { EventProxy } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class XamBulletGraph extends Control implements INotifyPropertyChanged {
    static $t: Type;
    private fk;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected fr(a: string): void;
    constructor();
    aw: DoubleAnimator;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    private e8;
    get a7(): boolean;
    private bp;
    get cz(): number;
    set cz(a: number);
    private f4;
    private get bc();
    formatLabel: (sender: any, args: FormatLinearGraphLabelEventArgs) => void;
    alignLabel: (sender: any, args: AlignLinearGraphLabelEventArgs) => void;
    protected an: BulletGraphFrame;
    protected am: BulletGraphFrame;
    protected al: BulletGraphFrame;
    protected ar: LinearGraphScaler;
    as: LinearScaleOrientation;
    private av;
    get h2(): Brush;
    set h2(a: Brush);
    static readonly g4: DependencyProperty;
    get h3(): Brush;
    set h3(a: Brush);
    static readonly g5: DependencyProperty;
    get ch(): number;
    set ch(a: number);
    static readonly g6: DependencyProperty;
    ranges: LinearGraphRangeCollection;
    ah: BrushCollection;
    ai: BrushCollection;
    b7: number;
    private bm;
    get bs(): number;
    set bs(a: number);
    b6: number;
    private bl;
    get br(): number;
    set br(a: number);
    cn: number;
    el: string;
    c0: number;
    e2: string;
    bz: number;
    private a1;
    private bk;
    get bq(): number;
    set bq(a: number);
    b0: number;
    f7(): void;
    private ay;
    get az(): HighlightedValueDisplayMode;
    set az(a: HighlightedValueDisplayMode);
    f6(): void;
    a0: HighlightedValueDisplayMode;
    private fd;
    cf: number;
    cg: number;
    c1: number;
    c2: number;
    b1: number;
    cu: number;
    cv: number;
    b3: number;
    b2: number;
    b4: number;
    b5: number;
    b8: number;
    cw: number;
    cs: number;
    cy: number;
    h6: Brush;
    hz: Brush;
    h7: Brush;
    h8: Brush;
    c3: number;
    cb: number;
    b9: number;
    cd: number;
    h1: Brush;
    a9: boolean;
    hx: Brush;
    hy: Brush;
    bw: number;
    bu: number;
    bv: number;
    cm: number;
    cj: number;
    h4: Brush;
    co: number;
    cp: number;
    cq: number;
    h5: Brush;
    cr: number;
    bb: boolean;
    dr: string;
    ag: any[];
    aj: BindingFormatter;
    c7: number;
    c6: number;
    toolTip: any;
    bd: boolean;
    dh: string;
    a5: StackPool$1<Path>;
    a3: StackPool$1<Path>;
    a2: StackPool$1<TextBlock>;
    a6: StackPool$1<TextBlock>;
    a4: StackPool$1<Path>;
    by(a: Point): number;
    at(): BulletGraphVisualData;
    dg(): string;
    destroy(): void;
    provideContainer(a: any): void;
    onMouseOver(a: Point, b: boolean, c: boolean): void;
    onMouseLeave(): void;
    containerResized(): void;
    f5(): void;
    fc(): void;
    private bj;
    private f3;
    private fw;
    private _view;
    get view(): XamBulletGraphView;
    set view(a: XamBulletGraphView);
    private ic;
    get ig(): Rect;
    set ig(a: Rect);
    private ib;
    get ie(): Rect;
    set ie(a: Rect);
    private ia;
    get id(): Rect;
    set id(a: Rect);
    private bo;
    get ce(): number;
    set ce(a: number);
    private bn;
    get bt(): number;
    set bt(a: number);
    protected ba(): boolean;
    e9(): void;
    private bf;
    private bi;
    private bh;
    private bg;
    private fo;
    private ih;
    private fn;
    private be;
    private fm;
    private fp;
    private fq;
    private aq;
    h0(a: number, b: BrushCollection): Brush;
    private f1;
    private fy;
    private fz;
    private fx;
    private f0;
    private f2;
    private fl;
    private fg;
    private ci;
    private ck;
    private c4;
    private c5;
    private cl;
    private h9;
    private fj;
    private fu;
    private ft;
    protected a8: boolean;
    refresh(): void;
    ax(): FontInfo;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class XamBulletGraphView extends Base {
    static $t: Type;
    private ao;
    private an;
    private ap;
    constructor(a: XamBulletGraph);
    a4(): void;
    a8(): void;
    protected m: XamBulletGraph;
    protected i: EventProxy;
    private ai;
    private p;
    ag: DomRenderer;
    private aa;
    private z;
    private y;
    private ab;
    a9(): void;
    a0(): void;
    private ck;
    private cg;
    private cj;
    private ci;
    private cf;
    private ch;
    s(): boolean;
    cp(): Path;
    cq(): Path;
    cm(): Path;
    co(): Path;
    cl(): Path;
    cn(): Path;
    private b7;
    private b8;
    private b4;
    private b5;
    private b9;
    private ca;
    private b6;
    private c;
    private d;
    private e;
    private f;
    private cb;
    private cc;
    private q;
    private v;
    private a;
    private static w;
    private static g;
    private static h;
    private ay;
    private bx;
    private bw;
    a5(a: string, b: any, c: any): void;
    ba(a: BrushCollection, b: BrushCollection): void;
    bb(a: BrushCollection, b: BrushCollection): void;
    b(a: string, b: string[]): string[];
    bs(): void;
    protected u: boolean;
    protected t: boolean;
    private ah;
    protected k: LinearGraphTooltipDataContext;
    private aj;
    private al;
    ce(a: Point): Point;
    private aq;
    private am;
    private cd;
    private ak;
    br(a: Point, b: any, c: number, d: string): void;
    az(): void;
    private bn;
    private bz;
    private j;
    a6(a: any): void;
    private at;
    private av;
    private au;
    a7(): void;
    as(): void;
    private x;
    bp(a: List$1<Path>): void;
    private bm;
    by(): void;
    ae(a: any): number;
    ct(a: TextBlock): Size;
    private b3;
    bq(a: TextBlock, b: Brush): void;
    bh(a: TextBlock, b: number, c: number): void;
    bg(a: number, b: number): void;
    bi(a: number, b: number): void;
    ad(a: FontInfo): number;
    private r;
    private n;
    private b2;
    private ac;
    bo(): void;
    ar(): void;
    flush(): void;
    private o;
    aw(a: BulletGraphVisualData): void;
    bj(a: Path): void;
    bk(a: Path): void;
    bl(a: Path): void;
    cs(): Path;
    bt(a: TextBlock): void;
    bu(a: TextBlock): void;
    bv(a: TextBlock): void;
    b1(): TextBlock;
    bc(a: Path): void;
    bd(a: Path): void;
    be(a: Path): void;
    cr(): Path;
    a1(a: TextBlock): void;
    a2(a: TextBlock): void;
    a3(a: TextBlock): void;
    b0(): TextBlock;
    l(): ToolTipInfo;
    bf(): void;
}
