import * as React from 'react';
import { XamRadialGaugeRange } from "./XamRadialGaugeRange";
export declare class IgrRadialGaugeRange extends React.Component<IIgrRadialGaugeRangeProps> {
    protected _implementation: any;
    get i(): XamRadialGaugeRange;
    private onImplementationCreated;
    constructor(props: IIgrRadialGaugeRangeProps);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): any;
    get rangeInternal(): XamRadialGaugeRange;
    protected createImplementation(): XamRadialGaugeRange;
    private _renderer;
    private _provideRenderer;
    static _createFromInternal(internal: any): IgrRadialGaugeRange;
    /**
 * Gets or sets the name of the range.
*/
    get name(): string;
    set name(v: string);
    /**
     * Gets or sets the brush to use to fill the range.
    */
    get brush(): string;
    set brush(v: string);
    /**
     * Gets or sets the outline to use when rendering the range.
    */
    get outline(): string;
    set outline(v: string);
    /**
     * Gets or sets the value at which the range starts along the scale.
    */
    get startValue(): number;
    set startValue(v: number);
    /**
     * Gets or sets the value at which the range ends along the scale.
    */
    get endValue(): number;
    set endValue(v: number);
    /**
     * Gets or sets the distance from the center of the gauge (from 0 to 1) at which to start rendering the inner sweep of the range.
     * Values further from zero than 1 can be used to make this extend further than the normal radius of the gauge.
    */
    get innerStartExtent(): number;
    set innerStartExtent(v: number);
    /**
     * Gets or sets the distance from the center of the gauge (from 0 to 1) at which to end rendering the inner sweep of the range.
     * Values further from zero than 1 can be used to make this extend further than the normal radius of the gauge.
    */
    get innerEndExtent(): number;
    set innerEndExtent(v: number);
    /**
     * Gets or sets the distance from the center of the gauge (from 0 to 1) at which to start rendering the outer sweep of the range.
     * Values further from zero than 1 can be used to make this extend further than the normal radius of the gauge.
    */
    get outerStartExtent(): number;
    set outerStartExtent(v: number);
    /**
     * Gets or sets the distance from the center of the gauge (from 0 to 1) at which to end rendering the outer sweep of the range.
     * Values further from zero than 1 can be used to make this extend further than the normal radius of the gauge.
    */
    get outerEndExtent(): number;
    set outerEndExtent(v: number);
    /**
     * Gets or sets the stroke thickness to use when rendering this range's outline.
    */
    get strokeThickness(): number;
    set strokeThickness(v: number);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
export interface IIgrRadialGaugeRangeProps {
    /**
 * Gets or sets the name of the range.
*/
    name?: string;
    /**
     * Gets or sets the brush to use to fill the range.
    */
    brush?: string;
    /**
     * Gets or sets the outline to use when rendering the range.
    */
    outline?: string;
    /**
     * Gets or sets the value at which the range starts along the scale.
    */
    startValue?: number | string;
    /**
     * Gets or sets the value at which the range ends along the scale.
    */
    endValue?: number | string;
    /**
     * Gets or sets the distance from the center of the gauge (from 0 to 1) at which to start rendering the inner sweep of the range.
     * Values further from zero than 1 can be used to make this extend further than the normal radius of the gauge.
    */
    innerStartExtent?: number | string;
    /**
     * Gets or sets the distance from the center of the gauge (from 0 to 1) at which to end rendering the inner sweep of the range.
     * Values further from zero than 1 can be used to make this extend further than the normal radius of the gauge.
    */
    innerEndExtent?: number | string;
    /**
     * Gets or sets the distance from the center of the gauge (from 0 to 1) at which to start rendering the outer sweep of the range.
     * Values further from zero than 1 can be used to make this extend further than the normal radius of the gauge.
    */
    outerStartExtent?: number | string;
    /**
     * Gets or sets the distance from the center of the gauge (from 0 to 1) at which to end rendering the outer sweep of the range.
     * Values further from zero than 1 can be used to make this extend further than the normal radius of the gauge.
    */
    outerEndExtent?: number | string;
    /**
     * Gets or sets the stroke thickness to use when rendering this range's outline.
    */
    strokeThickness?: number | string;
}
